ObjectArrayDeserializer (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.deser.std

## Class ObjectArrayDeserializer

- java.lang.Object
- - org.codehaus.jackson.map.JsonDeserializer<T>
  - - org.codehaus.jackson.map.deser.std.StdDeserializer<T>
    - - org.codehaus.jackson.map.deser.std.ContainerDeserializerBase<Object[]>
      - - org.codehaus.jackson.map.deser.std.ObjectArrayDeserializer

- Direct Known Subclasses:
    ArrayDeserializer

      public class ObjectArrayDeserializer
      extends ContainerDeserializerBase<Object[]>

  Basic serializer that can serialize non-primitive arrays.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `StdDeserializer.BigDecimalDeserializer, StdDeserializer.BigIntegerDeserializer, StdDeserializer.BooleanDeserializer, StdDeserializer.ByteDeserializer, StdDeserializer.CharacterDeserializer, StdDeserializer.DoubleDeserializer, StdDeserializer.FloatDeserializer, StdDeserializer.IntegerDeserializer, StdDeserializer.LongDeserializer, StdDeserializer.NumberDeserializer, StdDeserializer.PrimitiveOrWrapperDeserializer<T>, StdDeserializer.ShortDeserializer, StdDeserializer.SqlDateDeserializer, StdDeserializer.StackTraceElementDeserializer`

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_arrayType`
    `protected Class<?>` | `_elementClass` Type of contained elements: needed for constructing actual result array
    `protected JsonDeserializer<Object>` | `_elementDeserializer` Element deserializer
    `protected TypeDeserializer` | `_elementTypeDeserializer` If element instances have polymorphic type information, this is the type deserializer that can handle it
    `protected boolean` | `_untyped` Flag that indicates whether the component type is Object or not.

    - ### Fields inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_valueClass`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ObjectArrayDeserializer(ArrayType arrayType, JsonDeserializer<Object> elemDeser, TypeDeserializer elemTypeDeser)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object[]` | `deserialize(JsonParser jp, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `protected Byte[]` | `deserializeFromBase64(JsonParser jp, DeserializationContext ctxt)`
    `Object[]` | `deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `JsonDeserializer<Object>` | `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
    `JavaType` | `getContentType()` Accessor for declared type of contained value elements; either exact type, or one of its supertypes.

    - ### Methods inherited from class org.codehaus.jackson.map.deser.std.StdDeserializer

      `_parseBoolean, _parseBooleanFromNumber, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, findDeserializer, getValueClass, getValueType, handleUnknownProperty, isDefaultSerializer, parseDouble, reportUnknownProperty`

    - ### Methods inherited from class org.codehaus.jackson.map.JsonDeserializer

      `deserialize, getEmptyValue, getNullValue, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _arrayType

          protected final JavaType _arrayType

    - #### _untyped

          protected final boolean _untyped

      Flag that indicates whether the component type is Object or not. Used for minor optimization when constructing result.

    - #### _elementClass

          protected final Class<?> _elementClass

      Type of contained elements: needed for constructing actual result array

    - #### _elementDeserializer

          protected final JsonDeserializer<Object> _elementDeserializer

      Element deserializer

    - #### _elementTypeDeserializer

          protected final TypeDeserializer _elementTypeDeserializer

      If element instances have polymorphic type information, this is the type deserializer that can handle it

  - ### Constructor Detail

    - #### ObjectArrayDeserializer

          public ObjectArrayDeserializer(ArrayType arrayType,
                                 JsonDeserializer<Object> elemDeser,
                                 TypeDeserializer elemTypeDeser)

  - ### Method Detail

    - #### getContentType

          public JavaType getContentType()

      Description copied from class: `ContainerDeserializerBase`
      Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
      Specified by:
        `getContentType` in class `ContainerDeserializerBase<Object[]>`

    - #### getContentDeserializer

          public JsonDeserializer<Object> getContentDeserializer()

      Description copied from class: `ContainerDeserializerBase`
      Accesor for deserializer use for deserializing content values.
      Specified by:
        `getContentDeserializer` in class `ContainerDeserializerBase<Object[]>`

    - #### deserialize

          public Object[] deserialize(JsonParser jp,
                             DeserializationContext ctxt)
                               throws IOException,
                                      JsonProcessingException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker. Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Object[]>`
      Parameters:
        `jp` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserializer value
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeWithType

          public Object[] deserializeWithType(JsonParser jp,
                                     DeserializationContext ctxt,
                                     TypeDeserializer typeDeserializer)
                                       throws IOException,
                                              JsonProcessingException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<Object[]>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### deserializeFromBase64

          protected Byte[] deserializeFromBase64(JsonParser jp,
                                     DeserializationContext ctxt)
                                          throws IOException,
                                                 JsonProcessingException

      Throws:
        `IOException`
        `JsonProcessingException`